#ifndef BENCHMARK_HPP_BhjgkfG8
#define BENCHMARK_HPP_BhjgkfG8

#include "codecs.hpp"
#include "scheduler.hpp"

#if __cplusplus >= 201103L // C++ 2011
    #include <cstdint>
#else
extern "C"
{
    #include <stdint.h>
}
#endif // C++ 2011s

struct EncodeParams
{
    encoder_t encoder;
    Scheduler* scheduler;
    void* other;
    size_t workbsize; // size of each input block
    size_t bsize; // size of actual data in an input block; ibsize - padding
    size_t ssize;
    bool verify;
    uintmax_t successfully_encoded_bytes;//number of bytes processed successfully. I.e. when compressing incompressible data expected to be 0. Summed up across small iterations, can yield a large number.
    uintmax_t encoded_bytes;
    bool can_skip;
};
struct DecodeParams
{
    decoder_t decoder;
    Scheduler* scheduler;
    void* other;
    size_t workbsize; // size of each input block
    size_t ssize;
    bool verify;
    uintmax_t ret;
};

#endif // BENCHMARK_HPP_BhjgkfG8
